<template>
  <div class="q-pa-md row">
    <div class="col col-md-3 col-sm-12 col-xs-12 q-pa-md">
      <TaskForm :activeId="activeId" v-model="activeId" @getData="getData()" />
    </div>

    <div class="col col-md-9 col-sm-12 col-xs-12">
      <div class="row">
        <div class="col col-6">
          <q-input
            class="q-my-md"
            color="green-10"
            v-model="search"
            label="Search"
          >
            <template v-slot:prepend>
              <q-icon name="search" />
            </template>
          </q-input>
        </div>
      </div>
      <q-table
        :title="todo_name"
        :grid="$q.screen.sm"
        :flat="!$q.screen.sm"
        bordered
        :rows="copy_rows"
        :columns="columns"
        row-key="title"
        separator="none"
        :rows-per-page-options="[0]"
        :loading="loading"
      >
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td key="title" :props="props">
              {{ props.row.title }}
            </q-td>
            <q-td key="description" :props="props">
              {{ props.row.description }}
            </q-td>
            <q-td key="due_date" :props="props">
              {{ props.row.due_date }}
            </q-td>
            <q-td key="priority" :props="props">
              {{ props.row.priority }}
            </q-td>
            <q-td key="action" :props="props">
              <q-icon
                name="edit"
                class=""
                size="2em"
                @click="showUpdateTaskInfo(props.row.id)"
              />
              <q-icon
                name="delete"
                class=""
                size="2em"
                @click="deleteTask(props.row.id)"
              />
            </q-td>
          </q-tr>
        </template>
      </q-table>
    </div>

    <div></div>
  </div>
</template>

<script setup>
import axios from "axios";
import { computed, onMounted, reactive, ref } from "vue";
import { useRoute, useRouter } from "vue-router";
import TaskForm from "../components/Task/TaskForm.vue";

const columns = [
  {
    name: "title",
    required: true,
    label: "Title",
    align: "left",
    field: (row) => row.title,
    format: (val) => `${val}`,
    sortable: true,
  },
  {
    name: "description",
    align: "left",
    label: "Description",
    field: "description",
    sortable: true,
  },
  { name: "due_date", label: "Due Date", field: "due_date", sortable: true },

  { name: "priority", label: "Priority", field: "priority", sortable: true },
  { name: "action", label: "", field: "action", sortable: false },
];
const route = useRoute();
let loading = ref(false);
let rows = reactive([]);
let activeId = ref();
let todo_name = ref();

// -----------------lifecycle
onMounted(() => {
  getData();
  getParent();
});
// -----------------lifecycle
// -----------------crud
function getParent() {
  axios
    .get(
      `https://todolist-965e6-default-rtdb.firebaseio.com/todo/${route.params.id}.json`
    )
    .then((response) => { 
      let data = response.data;
      todo_name.value = data.title;
    });
}

function getData() {
  loading.value = true;

  axios
    .get(`https://todolist-965e6-default-rtdb.firebaseio.com/task.json`)
    .then((response) => { 
      if (response.data) {
        let all_data = Object.entries(response.data);
        for (let i = 0; i < all_data.length; i++) {
          const element = all_data[i];
          if (element[1].to_do_id == route.params.id) {
            rows.push({
              id: element[0],
              title: element[1].title,
              description: element[1].description,
              due_date: element[1].due_date,
              priority: element[1].priority,
            });
          }
        }
      }

      loading.value = false;
    });
}

function showUpdateTaskInfo(id) {
  activeId.value = id;
}

function deleteTask(id) {
  axios
    .delete(
      `https://todolist-965e6-default-rtdb.firebaseio.com/task/${id}.json`
    )
    .then((response) => {
      getData();
    });
}
// -----------------crud

let search = ref("");
let copy_rows = computed(() => {
  if (search.value == "") {
    return rows;
  } else {
    let filtered = rows.filter(
      (x) =>
        x.title.toLowerCase().includes(search.value) ||
        x.description.toLowerCase().includes(search.value)
    );
    return filtered;
  }
});
</script>
